package com.muyu.kafka;

import com.muyu.iotDB.service.IotDbServer;
import com.muyu.mqtt.dao.MessageData;
import lombok.extern.log4j.Log4j2;
import org.apache.iotdb.rpc.IoTDBConnectionException;
import org.apache.iotdb.rpc.StatementExecutionException;
import org.apache.kafka.clients.consumer.ConsumerConfig;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.apache.kafka.common.TopicPartition;
import org.apache.kafka.common.serialization.StringDeserializer;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import javax.annotation.Resource;
import java.rmi.ServerException;
import java.time.Duration;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Properties;

/**
 * 定时器 SimpleKafkaConsumer
 *
 * @author Yangle
 * Date 2024/6/16 22:18
 */
@Component
@Log4j2
public class SimpleKafkaConsumer {

    @Resource
    private IotDbServer iotDbServer;


//    @KafkaListener(topics = "test1", groupId = "Partitions")
//    public void consumer() throws ServerException, IoTDBConnectionException, StatementExecutionException {
//        log.info("定时器开启");
////        List<MessageData> messageDataList = new ArrayList<>();
////        // 配置Kafka消费者属性
//        Properties props = new Properties();
//        props.put(ConsumerConfig.BOOTSTRAP_SERVERS_CONFIG, "localhost:9092");
//        props.put(ConsumerConfig.GROUP_ID_CONFIG, "Partitions");
//        props.put(ConsumerConfig.KEY_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class.getName());
//        props.put(ConsumerConfig.VALUE_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class.getName());
//        props.put(ConsumerConfig.AUTO_OFFSET_RESET_CONFIG, "earliest");
//
////        // 创建Kafka消费者实例
//        KafkaConsumer<String, String> consumer = new KafkaConsumer<>(props);
//        // 持续消费消息
//        while (true) {
//            ConsumerRecords<String, String> records = consumer.poll(Duration.ofMillis(100));
//            for (ConsumerRecord<String, String> record : records) {
//                System.out.printf("offset = %d, key = %s, value = %s%n", record.offset(), record.key(), record.value());
//                String value = record.value();
//                log.info("value:{}",value);
//                MessageData messageData1 = com.alibaba.fastjson2.JSONObject.parseObject(value, MessageData.class);
//                log.info("messageData1:{}",messageData1);
//                iotDbServer.add(messageData1);
//            }
//
//        }
//    }

    @KafkaListener(topics = "test1", groupId = "Partitions")
    public void consumer(ConsumerRecord<String, String> record) throws ServerException, IoTDBConnectionException, StatementExecutionException {
        log.info("Received message");
        String value = record.value();
        log.info("value:{}", value);
        MessageData messageData1 = com.alibaba.fastjson2.JSONObject.parseObject(value, MessageData.class);
        log.info("messageData1:{}", messageData1);
        iotDbServer.add(messageData1);
    }


}

