package com.muyu.mqtt;



import com.alibaba.fastjson.JSON;
import com.muyu.mqtt.dao.MessageData;
import com.muyu.utils.ConversionUtil;
import lombok.extern.log4j.Log4j2;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaAdmin;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;

/**
 * 回执消息类 MessageCallbackService
 *
 * @author Yangle
 * Date 2024/6/6 15:08
 */
@Service
@Log4j2
public class MessageCallbackService implements MqttCallback {

    @Autowired
    private KafkaTemplate kafkaTemplate;
    @Autowired
    private KafkaAdmin kafkaAdmin;

    @Override
    public void connectionLost(Throwable cause) {
        System.out.println("connectionLost:"+cause.getMessage());
    }


    @Override
    public void messageArrived(String topic, MqttMessage mqttMessage) {
        log.info("topic:{}",topic);
        log.info("Qos:{}",mqttMessage.getQos());
        log.info("message content:{}",new String(mqttMessage.getPayload()));
        String s = new String(mqttMessage.getPayload());
        MessageData main = ConversionUtil.main(s);
//           try {
//            List<NewTopic> newTopicList = createTopic(topic,main);
//            for (NewTopic newTopic : newTopicList) {
////                int partitionIndex = getPartitionIndexWithWeight(newTopic.getPartitions());
//                kafkaAdmin.createOrModifyTopics(newTopic);
//                ProducerRecord<String, String> stringObjectProducerRecord = new ProducerRecord<>(topic, main.getVin(), main.toString());
//                kafkaTemplate.send(stringObjectProducerRecord);
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
        ProducerRecord<String, String> stringObjectProducerRecord = new ProducerRecord<>(topic, main.getVin(), JSON.toJSONString(main));
        kafkaTemplate.send(stringObjectProducerRecord);
    }
    private int currentPartitionIndex = 0;


//    public  List<NewTopic> createTopic(String topic,MessageData messageData) {
//        // 创建Kafka生产者实例
//        List<NewTopic> newTopics = new ArrayList<>();
//        newTopics.add(new NewTopic(topic, 8, (short) 1));
////        ProducerRecord<String, String> stringObjectProducerRecord = new ProducerRecord<>(topic, messageData.getVin(), messageData.toString());
////           kafkaTemplate.send(stringObjectProducerRecord);
//        return newTopics;
//    }

//    public static int getPartitionIndexWithWeight(List<PartitionInfo> partitions) {
//        int totalWeight = 0;
//        for (PartitionInfo partition : partitions) {
//            totalWeight += partition.getReplicas().size();
//        }
//
//        int randomNum = new Random().nextInt(totalWeight);
//        int currentWeight = 0;
//        for (int i = 0; i < partitions.size(); i++) {
//            currentWeight += partitions.get(i).getReplicas().size();
//            if (randomNum < currentWeight) {
//                return i;
//            }
//        }
//
//        return -1; // should never reach here
//    }


    @Override
    public void deliveryComplete(IMqttDeliveryToken token) {
        System.out.println("deliveryComplete---------" + token.isComplete());
    }
}
